package com.example.module_android_demo;

import android.app.Application;
import android.app.TabActivity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.PowerManager;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ListView;
import android.widget.TabHost;
import android.widget.TabHost.OnTabChangeListener;
import android.widget.TabHost.TabSpec;
import android.widget.TabWidget;
import android.widget.TextView;
import android.widget.Toast;

import com.function.AndroidWakeLock;
import com.function.MyAdapter;
import com.function.MyEpListAdapter;
import com.function.SPconfig;
import com.function.ScreenListener;
import com.function.ScreenListener.ScreenStateListener;
import com.pow.api.cls.RfidPower;
import com.pow.api.cls.RfidPower.PDATYPE;
import com.uhf.api.cls.BackReadOption;
import com.uhf.api.cls.ErrInfo;
import com.uhf.api.cls.ReadExceptionListener;
import com.uhf.api.cls.ReadListener;
import com.uhf.api.cls.Reader;
import com.uhf.api.cls.Reader.AntPower;
import com.uhf.api.cls.Reader.AntPowerConf;
import com.uhf.api.cls.Reader.EmbededData_ST;
import com.uhf.api.cls.Reader.HardwareDetails;
import com.uhf.api.cls.Reader.HoptableData_ST;
import com.uhf.api.cls.Reader.Inv_Potl;
import com.uhf.api.cls.Reader.Inv_Potls_ST;
import com.uhf.api.cls.Reader.Mtr_Param;
import com.uhf.api.cls.Reader.READER_ERR;
import com.uhf.api.cls.Reader.Region_Conf;
import com.uhf.api.cls.Reader.SL_TagProtocol;
import com.uhf.api.cls.Reader.TAGINFO;
import com.uhf.api.cls.Reader.TagFilter_ST;

import java.io.DataOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

@SuppressWarnings("deprecation")
public class MainActivity extends TabActivity {

	ExpandableListView tab4_left, tab4_right;
	TextView tv_once, tv_state, tv_tags, tv_costt;
	Button button_read, button_stop, button_clear;
	private ListView listView;

	Map<String, TAGINFO> TagsMap = new LinkedHashMap<String, TAGINFO>();
	private Handler handler = new Handler();
	private MyApplication myapp;
	private SoundPool soundPool;
	TabHost tabHost;
	ScreenListener l;
	AndroidWakeLock Awl;
	int Test_count = 0;
	boolean autostop;

	boolean RULE_NOSELPT = false;
	PDATYPE PT = PDATYPE.IDATA;

	List<Map<String, ?>> ListMs = new ArrayList<Map<String, ?>>();
	MyAdapter Adapter;
	Map<String, String> h = new HashMap<String, String>();

	public class MyBroadcastReceiver extends BroadcastReceiver {
		public static final String TAG = "MyBroadcastReceiver";

		@Override
		public void onReceive(Context context, Intent intent) {

			TAGINFO tfs = myapp.Mreader.new TAGINFO();
			tfs.AntennaID = intent.getByteExtra("ANT", (byte) 1);
			tfs.CRC = intent.getByteArrayExtra("CRC");
			tfs.EmbededData = intent.getByteArrayExtra("EMD");
			tfs.EmbededDatalen = intent.getShortExtra("EML", (short) 0);

			tfs.EpcId = intent.getByteArrayExtra("EPC");
			tfs.Epclen = intent.getShortExtra("EPL", (short) 0);
			tfs.Frequency = intent.getIntExtra("FRQ", 0);
			tfs.PC = intent.getByteArrayExtra("PC");
			tfs.Phase = intent.getIntExtra("PHA", 0);
			tfs.ReadCnt = intent.getIntExtra("RDC", 0);
			tfs.Res = intent.getByteArrayExtra("RES");
			tfs.RSSI = intent.getIntExtra("RSI", 0);
			tfs.TimeStamp = intent.getIntExtra("TSP", 0);

			TagsBufferResh(Reader.bytes_Hexstr(tfs.EpcId), tfs);
			int cll = TagsMap.size();
			if (cll < 0)
				cll = 0;
			tv_tags.setText(String.valueOf(cll));
			Adapter.notifyDataSetChanged();
		}
	}

	public Handler handler2 = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			Bundle bd = msg.getData();
			switch (msg.what) {
				case 0: {
					String count = bd.get("Msg_cnt").toString();
					tv_once.setText(count);
					tv_tags.setText(bd.get("Msg_all").toString());
					break;
				}

				case 1: {
					button_read.setText(getString(R.string.Constr_READ));
					tv_state.setText(bd.get("Msg_error_1").toString());
					// button_stop.performClick();
					break;
				}

				case 2: {
					tv_state.setText(bd.get("Msg_error_2").toString());
					break;
				}

				case 3: {
					StopHandleUI();
					break;
				}
			}
		}
	};

	public static boolean runRootCommand(String command) {
		Process process = null;
		DataOutputStream os = null;

		try {
			process = Runtime.getRuntime().exec("sh");// Runtime.getRuntime().exec("su");
			os = new DataOutputStream(process.getOutputStream());
			os.writeBytes(command + "\n");
			os.writeBytes("exit\n");
			os.flush();
			process.waitFor();
		} catch (Exception e) {
			Log.d("Phone Link", "su root - the device is not rooted,  error message�� " + e.getMessage());
			return false;
		} finally {
			try {
				if (null != os) {
					os.close();
				}
				if (null != process) {
					process.destroy();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return true;
	}

	MyEpListAdapter mttab1adp;

	private boolean reconnect() {
		Log.d("MYINFO", "reconenct");
		boolean blen = myapp.Rpower.PowerUp();
		if (!blen)
			return false;

		Toast.makeText(MainActivity.this, getString(R.string.Constr_mainpu, String.valueOf(blen)), Toast.LENGTH_SHORT)
				.show();

		READER_ERR er = myapp.Mreader.InitReader_Notype(myapp.Address, myapp.antportc);
		if (er == READER_ERR.MT_OK_ERR) {
			tv_state.setText("");
			myapp.needreconnect = false;
			
			try {
				myapp.Rparams = myapp.spf.ReadReaderParams();

				if (myapp.Rparams.invpro.size() < 1)
					myapp.Rparams.invpro.add("GEN2");

				List<SL_TagProtocol> ltp = new ArrayList<SL_TagProtocol>();
				for (int i = 0; i < myapp.Rparams.invpro.size(); i++) {
					if (myapp.Rparams.invpro.get(i).equals("GEN2")) {
						ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_GEN2);
					} else if (myapp.Rparams.invpro.get(i).equals("6B")) {
						ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_ISO180006B);
					} else if (myapp.Rparams.invpro.get(i).equals("IPX64")) {
						ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_IPX64);
					} else if (myapp.Rparams.invpro.get(i).equals("IPX256")) {
						ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_IPX256);
					}
				}

				Inv_Potls_ST ipst = myapp.Mreader.new Inv_Potls_ST();
				ipst.potlcnt = ltp.size();
				ipst.potls = new Inv_Potl[ipst.potlcnt];
				SL_TagProtocol[] stp = ltp.toArray(new SL_TagProtocol[ipst.potlcnt]);
				for (int i = 0; i < ipst.potlcnt; i++) {
					Inv_Potl ipl = myapp.Mreader.new Inv_Potl();
					ipl.weight = 30;
					ipl.potl = stp[i];
					ipst.potls[0] = ipl;
				}

				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_INVPOTL, ipst);
				Log.d("MYINFO", "Connected set pro:" + er.toString());

				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_READER_IS_CHK_ANT,
						new int[] { myapp.Rparams.checkant });
				Log.d("MYINFO", "Connected set checkant:" + er.toString());

				AntPowerConf apcf = myapp.Mreader.new AntPowerConf();
				apcf.antcnt = myapp.antportc;
				for (int i = 0; i < apcf.antcnt; i++) {
					AntPower jaap = myapp.Mreader.new AntPower();
					jaap.antid = i + 1;
					jaap.readPower = (short) myapp.Rparams.rpow[i];
					jaap.writePower = (short) myapp.Rparams.wpow[i];
					apcf.Powers[i] = jaap;
				}

				myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_RF_ANTPOWER, apcf);

				Region_Conf rre;
				switch (myapp.Rparams.region) {
				case 0:
					rre = Region_Conf.RG_PRC;
					break;
				case 1:
					rre = Region_Conf.RG_NA;
					break;
				case 2:
					rre = Region_Conf.RG_NONE;
					break;
				case 3:
					rre = Region_Conf.RG_KR;
					break;
				case 4:
					rre = Region_Conf.RG_EU;
					break;
				case 5:
				case 6:
				case 7:
				case 8:
				default:
					rre = Region_Conf.RG_NONE;
					break;
				}
				if (rre != Region_Conf.RG_NONE) {
					er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_FREQUENCY_REGION, rre);
				}

				if (myapp.Rparams.frelen > 0) {

					HoptableData_ST hdst = myapp.Mreader.new HoptableData_ST();
					hdst.lenhtb = myapp.Rparams.frelen;
					hdst.htb = myapp.Rparams.frecys;
					er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_FREQUENCY_HOPTABLE, hdst);
				}

				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_SESSION, new int[] { myapp.Rparams.session });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_Q, new int[] { myapp.Rparams.qv });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_WRITEMODE, new int[] { myapp.Rparams.wmode });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_MAXEPCLEN,
						new int[] { myapp.Rparams.maxlen });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_TARGET, new int[] { myapp.Rparams.target });

				if (myapp.Rparams.filenable == 1) {
					TagFilter_ST tfst = myapp.Mreader.new TagFilter_ST();
					tfst.bank = myapp.Rparams.filbank;
					tfst.fdata = new byte[myapp.Rparams.fildata.length() / 2];
					myapp.Mreader.Str2Hex(myapp.Rparams.fildata, myapp.Rparams.fildata.length(), tfst.fdata);
					tfst.flen = tfst.fdata.length * 8;
					tfst.startaddr = myapp.Rparams.filadr;
					tfst.isInvert = myapp.Rparams.filisinver;

					myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_FILTER, tfst);
				}

				if (myapp.Rparams.emdenable == 1) {
					EmbededData_ST edst = myapp.Mreader.new EmbededData_ST();

					edst.accesspwd = null;
					edst.bank = myapp.Rparams.emdbank;
					edst.startaddr = myapp.Rparams.emdadr;
					edst.bytecnt = myapp.Rparams.emdbytec;
					edst.accesspwd = null;

					er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_EMBEDEDDATA, edst);
				}

				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAGDATA_UNIQUEBYEMDDATA,
						new int[] { myapp.Rparams.adataq });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAGDATA_RECORDHIGHESTRSSI,
						new int[] { myapp.Rparams.rhssi });
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_SEARCH_MODE, new int[] { myapp.Rparams.invw });

			} catch (Exception ex) {
				Log.d("MYINFO", ex.getMessage() + ex.toString() + ex.getStackTrace());
			}
		} else
			return false;

		return true;
	}

	// ****************************************�¼���ʽ��ȡ��ǩ
	MyBroadcastReceiver mBroadcastReceiver = new MyBroadcastReceiver();
	public static final String BROADCAST_ACTION = "com.example.module_android_demo";

	READER_ERR StartReadTags() {
		// ��ʼ����BackReadOption
		BackReadOption m_BROption = new BackReadOption();
		// ����ֻʹ������1�����̴棬���Ҫʹ�ö��������ֻ��Ҫ��ʹ�õ����߱�
		// �Ÿ�ֵ������ants�У�����ͬʱʹ������1��2�������Ӧ�ø�Ϊants[0] = 1;
		// ants[1] = 2;antcnt = 2;
		int antcnt = 1;
		int[] ants = new int[antcnt];
		ants[0] = 1;
		/*
		 * �Ƿ���ø���ģʽ��Ŀǰֻ��slr11xx��slr12xxϵ�ж�д����֧�֣�,����
		 * һ���ǩ���������ٶȲ����Ӧ��û�б�Ҫʹ�ø���ģʽ,����û������ ʹ�ø���ģʽ
		 */
		m_BROption.IsFastRead = false;// ���÷Ǹ���ģʽ�̴��ǩ

		/// �Ǹ����̴�ģʽ�±���Ҫ���õĲ���*******************************************
		// �̴�����,��λΪms���ɸ���ʵ��ʹ�õ����߸�������ÿ��������Ҫ200ms
		// �ķ�ʽ����ó�,������ø���ģʽ���ѡ��û���κ����壬��������Ϊ
		// ����ֵ�����߸ɴ಻����
		m_BROption.ReadDuration = (short) (200 * antcnt);
		// �̴����ڼ���豸������ʱ��,��λΪms,һ�������Ϊ0�������豸������
		// ʱ�������ڽڵ�ͼ����豸���ȣ����ĳЩʹ�õ�ع����ռ�ṹ����
		// ��ɢ�ȵ�������а�����
		m_BROption.ReadInterval = 0;
		// ****************************************************************************

		// �����̴�ģʽ��������********************************************************
		// ����Ϊѡ��ʹ�ø���ģʽ�������õ�ѡ���,���������ü���,���ʹ�ܸ���
		// ģʽ������IsFastRead����Ϊtrue��,ֻ��ȡ�����±�ע�͵Ĵ��뼴��
		/*
		 * //����ģʽ��Ϊȡ�����Ч������Ϊ0���� m_BROption.FastReadDutyRation = 0;
		 * //��ǩ��Ϣ�Ƿ�Я��ʶ�����ߵı�� m_BROption.TMFlags.IsAntennaID = true;
		 * //��ǩ��Ϣ�Ƿ�Я����ǩʶ����� m_BROption.TMFlags.IsReadCnt = false;
		 * //��ǩ��Ϣ�Ƿ�Я��ʶ���ǩʱ���ź�ǿ�� m_BROption.TMFlags.IsRSSI = false; //��ǩ��Ϣ�Ƿ�Я��ʱ���
		 * m_BROption.TMFlags.IsTimestamp = false; //��ǩ��Ϣ�Ƿ�Я��ʶ���ǩʱ�Ĺ���Ƶ��
		 * m_BROption.TMFlags.IsFrequency = false;
		 * //��ǩ��Ϣ�Ƿ�Я��ʶ���ǩʱͬʱ��ȡ������bank������Ϣ,���Ҫ��ȡ��
		 * //�̴�ʱͬʱ��ȡ����bank����Ϣ����������MTR_PARAM_TAG_EMBEDEDDATA����,
		 * //��Ŀǰֻ��slr11xx��slr12xxϵ�ж�д����֧�֣� m_BROption.TMFlags.IsEmdData = false;
		 * //�����ֶΣ���ʼ������Ϊ0 m_BROption.TMFlags.IsRFU = false; //
		 */

		return myapp.Mreader.StartReading(ants, antcnt, m_BROption);
	}

	// ��ǩ�¼�
	ReadListener RL = new ReadListener() {
		@Override
		public void tagRead(Reader r, final TAGINFO[] tag) {
			// TODO Auto-generated method stub
			Intent intent = new Intent();
			intent.setAction(BROADCAST_ACTION);
			for (int i = 0; i < tag.length; i++) {
				intent.putExtra("ANT", tag[i].AntennaID);
				intent.putExtra("CRC", tag[i].CRC);
				intent.putExtra("EMD", tag[i].EmbededData);
				intent.putExtra("EML", tag[i].EmbededDatalen);

				intent.putExtra("EPC", tag[i].EpcId);
				intent.putExtra("EPL", tag[i].Epclen);
				intent.putExtra("FRQ", tag[i].Frequency);
				intent.putExtra("PC", tag[i].PC);
				intent.putExtra("PHA", tag[i].Phase);
				intent.putExtra("RDC", tag[i].ReadCnt);
				intent.putExtra("RES", tag[i].Res);
				intent.putExtra("RSI", tag[i].RSSI);
				intent.putExtra("TSP", tag[i].TimeStamp);

				sendBroadcast(intent);
			}
		}
	};
	
	ReadExceptionListener REL = new ReadExceptionListener() {
		@Override
		public void tagReadException(Reader r, final READER_ERR re) {
			// TODO Auto-generated method stub
			Message mes = new Message();
			mes.what = 2;
			Bundle bd = new Bundle();
			bd.putString("Msg_error_2", re.toString());
			mes.setData(bd);
			handler2.sendMessage(mes);
		}
	};
	// ************************************************//

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		String apkRoot = "chmod 777 " + getPackageCodePath();
		runRootCommand(apkRoot);

		soundPool = new SoundPool(10, AudioManager.STREAM_SYSTEM, 5);
		soundPool.load(this, R.raw.beep333, 1);
		Awl = new AndroidWakeLock((PowerManager) getSystemService(Context.POWER_SERVICE));

		Awl.WakeLock();
		tabHost = (TabHost) findViewById(android.R.id.tabhost);
		tabHost.setup();

		if (RULE_NOSELPT)
			;
		else
			tabHost.addTab(tabHost.newTabSpec("tab1")
					.setIndicator(getString(R.string.Constr_CONNECT), getResources().getDrawable(R.drawable.ic_launcher))
					.setContent(new Intent(this, Sub1TabActivity.class)));

		TabSpec tp = tabHost.newTabSpec("tab2").setIndicator(getString(R.string.Constr_INVENTORY)).setContent(R.id.tab2);

		tabHost.addTab(tp);
		tabHost.addTab(tabHost.newTabSpec("tab3")
				.setIndicator(getString(R.string.Constr_RWLOP),
						getResources().getDrawable(android.R.drawable.arrow_down_float))
				.setContent(new Intent(this, Sub3TabActivity.class)));

		tabHost.addTab(tabHost.newTabSpec("tab4")
				.setIndicator(getString(R.string.Constr_set), getResources().getDrawable(android.R.drawable.arrow_down_float))
				.setContent(new Intent(this, Sub4TabActivity.class)));

		TabWidget tw = tabHost.getTabWidget();
		if (RULE_NOSELPT)
			;
		else {
			tw.getChildAt(1).setVisibility(View.INVISIBLE);
			tw.getChildAt(2).setVisibility(View.INVISIBLE);
			tw.getChildAt(3).setVisibility(View.INVISIBLE);
		}

		Application app = getApplication();
		myapp = (MyApplication) app;
		myapp.Mreader = new Reader();
		myapp.Rparams = myapp.new ReaderParams();
		Coname = getResources().getStringArray(R.array.Coname);

		mBroadcastReceiver = new MyBroadcastReceiver();
		IntentFilter intentFilter = new IntentFilter();
		intentFilter.addAction(BROADCAST_ACTION);
		registerReceiver(mBroadcastReceiver, intentFilter);

		myapp.tabHost = tabHost;
		button_read = (Button) findViewById(R.id.button_start);
		button_stop = (Button) findViewById(R.id.button_stop);
		button_stop.setEnabled(false);
		button_clear = (Button) findViewById(R.id.button_readclear);
		listView = (ListView) findViewById(R.id.listView_epclist);

		tv_once = (TextView) findViewById(R.id.textView_readoncecnt);
		tv_state = (TextView) findViewById(R.id.textView_invstate);
		tv_tags = (TextView) findViewById(R.id.textView_readallcnt);
		tv_costt = (TextView) findViewById(R.id.textView_costtime);
		for (int i = 0; i < Coname.length; i++)
			h.put(Coname[i], Coname[i]);
		myapp.needreconnect = false;
		l = new ScreenListener(this);

		if (RULE_NOSELPT) {
			myapp.spf = new SPconfig(this);
			myapp.Rpower = new RfidPower(PT);
			String path = myapp.Rpower.GetDevPath();
			if (myapp.Rpower.PowerUp()) {
				READER_ERR er = myapp.Mreader.InitReader_Notype(path, 1);
				myapp.antportc = 1;
				myapp.Address = path;
				if (er == READER_ERR.MT_OK_ERR) {
					ConnectHandleUI();
				}
			}
		}

		l.begin(new ScreenStateListener() {
			@Override
			public void onScreenOn() {
			}

			@Override
			public void onScreenOff() {
				Log.d("MYINFO", "onScreenoff");
				if (button_stop.isEnabled()) {
					button_stop.performClick();
				}

				if (myapp.Mreader != null) {
					myapp.Mreader.CloseReader();
					myapp.needlisen = true;
				}

				if (myapp.Rpower != null) {
					myapp.Rpower.PowerDown();
					myapp.needreconnect = true;
				}
			}
		});

		button_read.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				try {

					if (Adapter == null) {
						ListMs.add(h);
						Adapter = new MyAdapter(getApplicationContext(), ListMs, R.layout.listitemview_inv, Coname,
								new int[] { R.id.textView_readsort, R.id.textView_readepc, R.id.textView_readcnt,
										R.id.textView_readant, R.id.textView_readpro, R.id.textView_readrssi,
										R.id.textView_readfre, R.id.textView_reademd });

						listView.setAdapter(Adapter);
					}

					boolean bl = true;
					if (myapp.needreconnect) {
						int c = 0;
						do {
							bl = reconnect();
							if (!bl)
								Toast.makeText(MainActivity.this, R.string.Constr_sub1recfailed,
										Toast.LENGTH_SHORT).show();
							c++;
							if (c > 0)
								break;
						} while (true);
					}
					if (!bl)
						return;

					if (myapp.nostop) {
						READER_ERR er = myapp.Mreader.AsyncStartReading(myapp.Rparams.uants, myapp.Rparams.uants.length,
								myapp.Rparams.option);
						if (er != READER_ERR.MT_OK_ERR) {
							Toast.makeText(MainActivity.this, R.string.Constr_nostopreadfailed, Toast.LENGTH_SHORT)
									.show();
							return;
						}
					}

					if (myapp.ThreadMODE == 0)
						handler.postDelayed(runnable_MainActivity, 0);
					else if (myapp.ThreadMODE == 1) {
						if (myapp.needlisen == true)
						{
							myapp.Mreader.addReadListener(RL);
							myapp.Mreader.addReadExceptionListener(REL);
							myapp.needlisen = false;
						}

						if (StartReadTags() != READER_ERR.MT_OK_ERR) {
							Toast.makeText(MainActivity.this, R.string.Constr_nostopreadfailed, Toast.LENGTH_SHORT)
									.show();
							return;
						}
					}

					myapp.TagsMap.clear();
					ReadHandleUI();

				} catch (Exception ex) {
					Toast.makeText(MainActivity.this, R.string.Constr_nostopreadfailed + ex.getMessage(),
							Toast.LENGTH_SHORT).show();
				}
			}
		});

		button_stop.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				if (myapp.nostop) {
					Log.d("MYINFO", "stop---");
					READER_ERR er = myapp.Mreader.AsyncStopReading();
					if (er != READER_ERR.MT_OK_ERR) {
						Toast.makeText(MainActivity.this, R.string.Constr_nostopspreadfailed, Toast.LENGTH_SHORT)
								.show();
						return;
					}
				}

				if (myapp.ThreadMODE == 0)
					handler.removeCallbacks(runnable_MainActivity);
				else if (myapp.ThreadMODE == 1) {
					if (myapp.Mreader.StopReading() != READER_ERR.MT_OK_ERR) {
						Toast.makeText(MainActivity.this, R.string.Constr_nostopspreadfailed, Toast.LENGTH_SHORT)
								.show();
						return;
					}
				}

				if (myapp.Rpower.GetType() == PDATYPE.SCAN_ALPS_ANDROID_CUIUS2) {
					try {
						Thread.sleep(500);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}

				Awl.ReleaseWakeLock();
				autostop = false;

				myapp.TagsMap.putAll(TagsMap);
				StopHandleUI();
			}
		});

		button_clear.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				if (Adapter != null) {
					TagsMap.clear();
					myapp.TagsMap.clear();
					ListMs.clear();
					// showlist();

					ListMs.add(h);
					Adapter.notifyDataSetChanged();
				}

				TextView et = (TextView) findViewById(R.id.textView_readoncecnt);
				et.setText("0");

				TextView et2 = (TextView) findViewById(R.id.textView_readallcnt);
				et2.setText("0");

				TextView et3 = (TextView) findViewById(R.id.textView_invstate);
				et3.setText("...");

				myapp.Curepc = "";
			}
		});

		this.listView.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				// TODO Auto-generated method stub
				arg1.setBackgroundColor(Color.YELLOW);

				@SuppressWarnings("unchecked")
				HashMap<String, String> hm = (HashMap<String, String>) listView.getItemAtPosition(arg2);
				String epc = hm.get("EPC ID");
				myapp.Curepc = epc;

				for (int i = 0; i < listView.getCount(); i++) {
					if (i != arg2) {
						View v = listView.getChildAt(i);
						if (v != null) {
							ColorDrawable cd = (ColorDrawable) v.getBackground();
							if (Color.YELLOW == cd.getColor()) {
								int[] colors = { Color.WHITE, Color.rgb(219, 238, 244) };// RGB��ɫ
								v.setBackgroundColor(colors[i % 2]);// ÿ��item֮����ɫ��ͬ
							}
						}
					}
				}
			}

		});

		tabHost.setOnTabChangedListener(new OnTabChangeListener() {
			@Override
			public void onTabChanged(String arg0) {
				int j = tabHost.getCurrentTab();
				if (RULE_NOSELPT) {
					if (j == 1) {
						Sub3TabActivity.EditText_sub3fildata.setText(myapp.Curepc);
						Sub3TabActivity.EditText_sub3wdata.setText(myapp.Curepc);
					}
				} else {
					if (j == 2) {
						Sub3TabActivity.EditText_sub3fildata.setText(myapp.Curepc);
						Sub3TabActivity.EditText_sub3wdata.setText(myapp.Curepc);
					}
				}
			}
		});
	}

	String[] Coname;// =new String[]{"���","EPC
					// ID","����","����","Э��","RSSI","Ƶ��","��������"};

	private void TagsBufferResh(String key, TAGINFO tfs) {
		if (!TagsMap.containsKey(key)) {
			TagsMap.put(key, tfs);

			// show
			Map<String, String> m = new HashMap<String, String>();
			m.put(Coname[0], String.valueOf(TagsMap.size()));

			String epcstr = Reader.bytes_Hexstr(tfs.EpcId);
			if (epcstr.length() < 24)
				epcstr = String.format("%-24s", epcstr);

			m.put(Coname[1], epcstr);
			String cs = m.get("����");
			if (cs == null)
				cs = "0";
			int isc = Integer.parseInt(cs) + tfs.ReadCnt;

			m.put(Coname[2], String.valueOf(isc));
			m.put(Coname[3], String.valueOf(tfs.AntennaID));
			m.put(Coname[4], "");
			m.put(Coname[5], String.valueOf(tfs.RSSI));
			m.put(Coname[6], String.valueOf(tfs.Frequency));

			if (tfs.EmbededDatalen > 0) {
				char[] out = new char[tfs.EmbededDatalen * 2];
				myapp.Mreader.Hex2Str(tfs.EmbededData, tfs.EmbededDatalen, out);
				m.put(Coname[7], String.valueOf(out));

			} else
				m.put(Coname[7], "                 ");

			ListMs.add(m);
		} else {
			TAGINFO tf = TagsMap.get(key);

			String epcstr = key;
			if (epcstr.length() < 24)
				epcstr = String.format("%-24s", epcstr);

			for (int k = 0; k < ListMs.size(); k++) {
				@SuppressWarnings("unchecked")
				Map<String, String> m = (Map<String, String>) ListMs.get(k);
				if (m.get(Coname[1]).equals(epcstr)) {
					tf.ReadCnt += tfs.ReadCnt;
					tf.RSSI = tfs.RSSI;
					tf.Frequency = tfs.Frequency;

					m.put(Coname[2], String.valueOf(tf.ReadCnt));
					m.put(Coname[5], String.valueOf(tf.RSSI));
					m.put(Coname[6], String.valueOf(tf.Frequency));
					break;
				}
			}
		}
	}

	private Runnable runnable_MainActivity = new Runnable() {
		public void run() {

			String[] tag = null;
			int[] tagcnt = new int[1];
			tagcnt[0] = 0;

			int streadt = 0, enreadt = 0;
			synchronized (this) {
				// Log.d("MYINFO", "ManActivity..1");
				READER_ERR er;
				streadt = (int) System.currentTimeMillis();
				if (myapp.nostop) {
					er = myapp.Mreader.AsyncGetTagCount(tagcnt);
				} else {
					er = myapp.Mreader.TagInventory_Raw(myapp.Rparams.uants, myapp.Rparams.uants.length,
							(short) myapp.Rparams.readtime, tagcnt);
				}
				// Log.d("MYINFO","read:" + er.toString() + " cnt:"+
				// String.valueOf(tagcnt[0]));

				if (er == READER_ERR.MT_OK_ERR) {
					if (tagcnt[0] > 0) {
						tv_once.setText(String.valueOf(tagcnt[0]));

						soundPool.play(1, 1, 1, 0, 0, 1);
						tag = new String[tagcnt[0]];
						for (int i = 0; i < tagcnt[0]; i++) {
							TAGINFO tfs = myapp.Mreader.new TAGINFO();
							if (myapp.Rpower.GetType() == PDATYPE.SCAN_ALPS_ANDROID_CUIUS2) {
								try {
									Thread.sleep(10);
								} catch (InterruptedException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
							if (myapp.nostop)
								er = myapp.Mreader.AsyncGetNextTag(tfs);
							else
								er = myapp.Mreader.GetNextTag(tfs);

							// Log.d("MYINFO","get tag index:" +
							// String.valueOf(i)+ " er:" + er.toString());
							if (er == READER_ERR.MT_HARDWARE_ALERT_ERR_BY_TOO_MANY_RESET) {

								tv_state.setText("error:" + String.valueOf(er.value()) + er.toString());
								myapp.needreconnect = true;
								button_stop.performClick();
								autostop = true;
							}

							// Log.d("MYINFO","debug gettag:"+er.toString());
							// Log.d("MYINFO","debug
							// tag:"+Reader.bytes_Hexstr(tfs.EpcId));

							if (er == READER_ERR.MT_OK_ERR) {
								tag[i] = Reader.bytes_Hexstr(tfs.EpcId);

								// ˢ�±�ǩ����
								TagsBufferResh(tag[i], tfs);

							} else
								break;
						}

						enreadt = (int) System.currentTimeMillis();
						tv_costt.setText("  " + String.valueOf(enreadt - streadt));

					}

				} else {
					tv_state.setText("error:" + String.valueOf(er.value()) + " " + er.toString());

					if (myapp.nostop && er != READER_ERR.MT_OK_ERR) {
						tv_state.setText("error:" + String.valueOf(er.value()) + er.toString());
						// button_stop.performClick();
						handler.removeCallbacks(runnable_MainActivity);
						myapp.TagsMap.putAll(TagsMap);
						StopHandleUI();
						autostop = true;
					}

					if (er == READER_ERR.MT_HARDWARE_ALERT_ERR_BY_TOO_MANY_RESET) {
						tv_state.setText("error:" + String.valueOf(er.value()) + er.toString());
						myapp.needreconnect = true;
						button_stop.performClick();
						autostop = true;
					} else
						handler.postDelayed(this, myapp.Rparams.sleep);
					return;
				}
			}

			if (tag == null) {
				tag = new String[0];
			} else {
				Adapter.notifyDataSetChanged();
			}

			int cll = TagsMap.size();
			if (cll < 0)
				cll = 0;
			tv_tags.setText(String.valueOf(cll));

			handler.postDelayed(this, myapp.Rparams.sleep);
		}
	};

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (!button_read.isEnabled()) {
			Toast.makeText(MainActivity.this, R.string.Constr_stopscan, Toast.LENGTH_SHORT).show();
		} else {

			if (id == R.id.action_system) {
				Intent intent = new Intent(MainActivity.this, SubSystemActivity.class);
				startActivityForResult(intent, 0);
				return true;
			} else if (id == R.id.action_qt) {
				Intent intent = new Intent(MainActivity.this, SubQTActivity.class);
				startActivityForResult(intent, 0);
				return true;
			} else if (id == R.id.action_lasterr) {
				ErrInfo ei = new ErrInfo();
				myapp.Mreader.GetLastDetailError(ei);
				Toast.makeText(MainActivity.this,
						getString(R.string.Constr_connectfialed) + "last:" + String.valueOf(ei.derrcode) + " " + ei.errstr,
						Toast.LENGTH_SHORT).show();
			}
		}

		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}

		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_main, container, false);
			return rootView;
		}
	}

	private void ReadHandleUI() {
		this.button_read.setEnabled(false);
		this.button_stop.setEnabled(true);
		TabWidget tw = myapp.tabHost.getTabWidget();
		if (RULE_NOSELPT) {
			tw.getChildAt(1).setEnabled(false);
			tw.getChildAt(2).setEnabled(false);
		} else {
			tw.getChildAt(0).setEnabled(false);
			tw.getChildAt(2).setEnabled(false);
			tw.getChildAt(3).setEnabled(false);
		}
	}

	private void StopHandleUI() {
		button_read.setEnabled(true);
		button_stop.setEnabled(false);
		TabWidget tw = myapp.tabHost.getTabWidget();
		if (RULE_NOSELPT) {
			tw.getChildAt(1).setEnabled(true);
			tw.getChildAt(2).setEnabled(true);
		} else {
			tw.getChildAt(0).setEnabled(true);
			tw.getChildAt(2).setEnabled(true);
			tw.getChildAt(3).setEnabled(true);
		}
	}

	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	protected void onDestroy() {
		Awl.ReleaseWakeLock();
		unregisterReceiver(mBroadcastReceiver);
		System.exit(0);
		super.onDestroy();
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
			if ((System.currentTimeMillis() - myapp.exittime) > 2000) {
				Toast.makeText(getApplicationContext(), R.string.Constr_Putandexit, Toast.LENGTH_SHORT).show();
				myapp.exittime = System.currentTimeMillis();
			} else {
				if (handler != null)
					handler.removeCallbacks(runnable_MainActivity);
				if (myapp.Mreader != null) {
					myapp.Mreader.CloseReader();
					myapp.needlisen = true;
				}

				myapp.Rpower.PowerDown();
				finish();
				// System.exit(0);
			}
			return true;
		} else if (keyCode == 139 && myapp.Rpower.GetType() == PDATYPE.CHAINWAY) {
			if (button_read.isEnabled()) {
				button_read.performClick();
			} else
				button_stop.performClick();
		}

		return super.onKeyDown(keyCode, event);
	}

	private void ConnectHandleUI() {
		try {
			READER_ERR er;
			myapp.Rparams = myapp.spf.ReadReaderParams();

			if (myapp.Rparams.invpro.size() < 1)
				myapp.Rparams.invpro.add("GEN2");

			List<SL_TagProtocol> ltp = new ArrayList<SL_TagProtocol>();
			for (int i = 0; i < myapp.Rparams.invpro.size(); i++) {
				if (myapp.Rparams.invpro.get(i).equals("GEN2")) {
					ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_GEN2);
				} else if (myapp.Rparams.invpro.get(i).equals("6B")) {
					ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_ISO180006B);
				} else if (myapp.Rparams.invpro.get(i).equals("IPX64")) {
					ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_IPX64);
				} else if (myapp.Rparams.invpro.get(i).equals("IPX256")) {
					ltp.add(SL_TagProtocol.SL_TAG_PROTOCOL_IPX256);
				}
			}

			Inv_Potls_ST ipst = myapp.Mreader.new Inv_Potls_ST();
			ipst.potlcnt = ltp.size();
			ipst.potls = new Inv_Potl[ipst.potlcnt];
			SL_TagProtocol[] stp = ltp.toArray(new SL_TagProtocol[ipst.potlcnt]);
			for (int i = 0; i < ipst.potlcnt; i++) {
				Inv_Potl ipl = myapp.Mreader.new Inv_Potl();
				ipl.weight = 30;
				ipl.potl = stp[i];
				ipst.potls[0] = ipl;
			}

			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_INVPOTL, ipst);
			Log.d("MYINFO", "Connected set pro:" + er.toString());

			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_READER_IS_CHK_ANT, new int[] { myapp.Rparams.checkant });
			Log.d("MYINFO", "Connected set checkant:" + er.toString());

			AntPowerConf apcf = myapp.Mreader.new AntPowerConf();
			apcf.antcnt = myapp.antportc;
			for (int i = 0; i < apcf.antcnt; i++) {
				AntPower jaap = myapp.Mreader.new AntPower();
				jaap.antid = i + 1;
				jaap.readPower = (short) myapp.Rparams.rpow[i];
				jaap.writePower = (short) myapp.Rparams.wpow[i];
				apcf.Powers[i] = jaap;
			}

			myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_RF_ANTPOWER, apcf);

			Region_Conf rre;
			switch (myapp.Rparams.region) {
				case 0:
					rre = Region_Conf.RG_PRC;
					break;
				case 1:
					rre = Region_Conf.RG_NA;
					break;
				case 2:
					rre = Region_Conf.RG_NONE;
					break;
				case 3:
					rre = Region_Conf.RG_KR;
					break;
				case 4:
					rre = Region_Conf.RG_EU;
					break;
				case 5:
				case 6:
				case 7:
				case 8:
				default:
					rre = Region_Conf.RG_NONE;
					break;
			}
			if (rre != Region_Conf.RG_NONE) {
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_FREQUENCY_REGION, rre);
			}

			if (myapp.Rparams.frelen > 0) {

				HoptableData_ST hdst = myapp.Mreader.new HoptableData_ST();
				hdst.lenhtb = myapp.Rparams.frelen;
				hdst.htb = myapp.Rparams.frecys;
				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_FREQUENCY_HOPTABLE, hdst);
			}

			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_SESSION, new int[] { myapp.Rparams.session });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_Q, new int[] { myapp.Rparams.qv });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_WRITEMODE, new int[] { myapp.Rparams.wmode });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_MAXEPCLEN, new int[] { myapp.Rparams.maxlen });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_POTL_GEN2_TARGET, new int[] { myapp.Rparams.target });

			if (myapp.Rparams.filenable == 1) {
				TagFilter_ST tfst = myapp.Mreader.new TagFilter_ST();
				tfst.bank = myapp.Rparams.filbank;
				tfst.fdata = new byte[myapp.Rparams.fildata.length() / 2];
				myapp.Mreader.Str2Hex(myapp.Rparams.fildata, myapp.Rparams.fildata.length(), tfst.fdata);
				tfst.flen = tfst.fdata.length * 8;
				tfst.startaddr = myapp.Rparams.filadr;
				tfst.isInvert = myapp.Rparams.filisinver;

				myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_FILTER, tfst);
			}

			if (myapp.Rparams.emdenable == 1) {
				EmbededData_ST edst = myapp.Mreader.new EmbededData_ST();

				edst.accesspwd = null;
				edst.bank = myapp.Rparams.emdbank;
				edst.startaddr = myapp.Rparams.emdadr;
				edst.bytecnt = myapp.Rparams.emdbytec;
				edst.accesspwd = null;

				er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_EMBEDEDDATA, edst);
			}

			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAGDATA_UNIQUEBYEMDDATA,
					new int[] { myapp.Rparams.adataq });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAGDATA_RECORDHIGHESTRSSI,
					new int[] { myapp.Rparams.rhssi });
			er = myapp.Mreader.ParamSet(Mtr_Param.MTR_PARAM_TAG_SEARCH_MODE, new int[] { myapp.Rparams.invw });

			TextView tv_module = (TextView) findViewById(R.id.textView_module);
			HardwareDetails val = myapp.Mreader.new HardwareDetails();
			er = myapp.Mreader.GetHardwareDetails(val);
			if (er == READER_ERR.MT_OK_ERR) {
				tv_module.setText(val.module.toString());
			}
		}
		catch (Exception ex) {
			Log.d("MYINFO", ex.getMessage() + ex.toString() + ex.getStackTrace());
		}
	}
}
